/*
 * $Id: ModSys.h 1047 2008-07-15 18:36:01Z sayer $
 *
 * Copyright (C) 2008 iptego GmbH
 *
 * This file is part of SEMS, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the SEMS software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * SEMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _MOD_SYS_H
#define _MOD_SYS_H
#include "DSMModule.h"

class SCSysModule 
: public DSMModule {

 public:
  SCSysModule();
  ~SCSysModule();
  
  DSMAction* getAction(const string& from_str);
  DSMCondition* getCondition(const string& from_str);
};

class FileExistsCondition 
: public DSMCondition {
  string arg;
  bool inv;

 public:

 FileExistsCondition(const string& arg, bool inv) 
   : arg(arg), inv(inv) { }
  bool match(AmSession* sess, DSMCondition::EventType event,
	     map<string,string>* event_params);
};

DEF_SCStrArgAction(SCMkDirAction);
#endif
